<?php 
include('../Code/confHeader.inc');
$_SESSION['Me'] -> goIfInvalid("../index.php");
$_SESSION['Me'] -> goIfNotAssistant('../index.php');
$Conf -> connect();
include('../Code/confConfigReview.inc');
include('../PC/gradeNames.inc');

function olink($key,$string)
{
  return "<a href=\"" . $_SERVER['PHP_SELF'] . "?orderBy=$key\"> $string </a>";
}

function show_paper_conflicts_as_table_row($conf, $paperId)
{
      $conflict_query = "SELECT firstName, lastName, email FROM PaperConflict, ContactInfo, PCMember WHERE paperId=$paperId AND authorId=ContactInfo.contactId AND authorId=PCMember.contactId ORDER BY lastName, firstName";
      // the GROUP BY just suppresses duplicates due to accidental double conflict specifications
      $conflict_result = $conf->qe($conflict_query);

      print "<tr> <th> PC Conflicts: </th> <td> ";
      $n_conflicts = 0;
      $div = "";
      if (DB::isError($conflict_result)) {
	print "db error";
      } else {
	while ($conflict_row = $conflict_result->fetchRow()) {
	  $f = 0;
	  $firstName = $conflict_row[$f++];
	  $lastName = $conflict_row[$f++];
	  $email = $conflict_row[$f++];
	  print $div . htmlentities($firstName) . " "
	    . htmlentities($lastName) . " &lt;"
	    . htmlentities($email) . "&gt;";
	  $div = ", ";
	  $n_conflicts++;
	};
      };
      if ($n_conflicts == 0) {
	print "none";
      };
      print "</td></tr>\n";
}

if (IsSet($_REQUEST['ShowPCPapers'])) {
  $showpc = $_REQUEST['ShowPCPapers'];
} else {
  $showpc = "all";
}

$showpc_options = array(
  'yes' => 'Show Only PC Member Papers',
  'no' => 'Do Not Show PC Member Papers',
  'all' => 'Show All Papers'
);

$graphs = array(
  "grade" => "PC Grade",
  "overAllMerit" => "Overall Merit",
  "reviewerQualification" => "Reviewer Qualification",
  "novelty" => "Novelty",
  "technicalMerit" => "Technical Merit",
  "grammar" => "Writing Quality"
  );

foreach( $graphs as $field => $name ){
   if( $field == 'grade' ){
     $meritRange[$field] = $Conf->reviewRange($field, 'PaperGrade');
   } else {
     $meritRange[$field] = $Conf->reviewRange($field, 'PaperReview');
   };
 };


 ?>

 <html>
 <style type=text/css>
 p.page {page-break-after: always}
 </style>


 <?php  $Conf->header("List All Paper Reviews") ?>

 <body>
 <?php 

 $ORDER="ORDER BY Paper.paperId";
 if (IsSet($_REQUEST['orderBy'])) {
   $ORDER = "ORDER BY " . $_REQUEST['orderBy'];
 }

 $summaryContactId = $_SESSION['Me']->contactId;
 if (IsSet($_REQUEST['summaryContactId']) && $_REQUEST['summaryContactId'] != 0) {
   $summaryContactId = $_REQUEST['summaryContactId'];
 }

 ?>
 <h2> List of submitted Reviews </h2>
 <p>
 This page shows you all the papers and abstracts that have been entered into the database.
 Under Microsoft Internet Explorer, you should be able to "Print" or "Print Preview" and it
 will print a single abstract per page (overly long abstracts may print on two pages).
 I am not certain if this works under Netscape or other browsers.
 </p>

 <FORM method="POST" action="<?php echo $_SERVER[PHP_SELF] ?>">
 <INPUT type=checkbox name=InsertPageBreaks value=1
    <?php  if ($_REQUEST['InsertPageBreaks']) {echo "checked";}?> > Insert page breaks between papers? </br>

 <INPUT type=checkbox name=SeeOnlyFinalized value=1
    <?php  if ($_REQUEST['SeeOnlyFinalized']) {echo "checked";}?> > See Only Finalized Reviews </br>

 <INPUT type=checkbox name=SeeAuthorInfo value=1
    <?php  if ($_REQUEST['SeeAuthorInfo']) {echo "checked";}?> > See Author Information </br>

 <INPUT type=checkbox name=SeeReviewerInfo value=1
    <?php  if ($_REQUEST['SeeReviewerInfo']) {echo "checked";}?> > See Reviewer Information </br>

 <INPUT type=checkbox name=SeeConflictInfo value=1
    <?php  if ($_REQUEST['SeeConflictInfo']) {echo "checked";}?> > See Conflict Information </br>

 <INPUT type=checkbox name=SeeOnlyDiscussed value=1
    <?php  if ($_REQUEST['SeeOnlyDiscussed']) {echo "checked";}?> > Show only papers that are scheduled for discussion </br>


 <SELECT name="ShowPCPapers">
 <?php
   foreach( $showpc_options as $name => $desc ){
     print "<OPTION VALUE='$name'";
     if( $name == $showpc ){
       print " SELECTED";
     }
     print ">$desc</A>\n";
   }
 ?>
 </SELECT>
 <p>
 Omit papers that conflict with:
 <?php
   $Conf->makePCSelector("summaryContactId", $summaryContactId, 1, "", "<OPTION VALUE=\"0\">no one</OPTION>");
 ?>
 <p>
 <input type="submit" value="Update View" name="submit">

 </FORM>


 <?php 

 if (IsSet($_REQUEST['paperReviewsToPrint'])) {
   $printThese = array();
   for ($i = 0; $i < sizeof($_REQUEST['paperReviewsToPrint']); $i++) {
     $id = $_REQUEST['paperReviewsToPrint'][$i];
     $printThese[$id] = 1;
   }
 }

 if( $showpc == "yes" ){
   $restrict = ' AND Paper.pcPaper = 1 ';
 } else if( $showpc == "no" ){
   $restrict = ' AND Paper.pcPaper = 0 ';
 } else {
   $restrict = '';
 }

 $query="SELECT Paper.paperId, Paper.title, Paper.abstract, Paper.authorsResponse, Paper.pcPaper, "
     . " ContactInfo.firstName, ContactInfo.lastName, "
     . " ContactInfo.email, ContactInfo.affiliation, Paper.authorInformation, "
     . " Paper.pcLeadId, Paper.discussionOrder "
     . " FROM Paper,ContactInfo "
     . " WHERE Paper.contactId=ContactInfo.contactId AND Paper.acknowledged=1 "
     . " $restrict ORDER BY paperId ";

 $result=$Conf->qe($query);
 print "<p> Found " .  $result->numRows() . " papers. </p>";

print "<p><big>Omitting papers that conflict with <b>";
if ($summaryContactId == 0) {
  print "(none omitted)";
} else {
  print $Conf->contactIdToHtml($summaryContactId);
};
print "</b></big>\n";

$page_break = (defined($_REQUEST['InsertPageBreaks'])) ? "CLASS=page" : "";

 print "<P $page_break> You should see a page break following this when printing. </p>";

 if (DB::isError($result)) {
   $Conf->errorMsg("Error in retrieving paper list " . $result->getMessage());
   exit();
 }
 while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
   $paperId=$row['paperId'];
   $printMe = 1;

   if (IsSet($_REQUEST['paperReviewsToPrint']) && ! $printThese[$paperId]) {
     $printMe = 0;
   }

   $title=$row['title'];
   $abstract=$row['abstract'];
   $authorsResponse=$row['authorsResponse'];
   $authorInfo = $row['authorInformation'];
   $contactInfo = $row['firstName'] . " " . $row['lastName']
     . " <" . $row['email'] . "> ";  // htmlified below
   $pcLeadId = $row['pcLeadId'];
   $discussionOrder = $row['discussionOrder'];

   $skip_color_cmd = "";
   $skip_reason = "";
   if ($Conf->checkConflict($paperId, $summaryContactId)) {
     $printMe = 0;
     $skip_color_cmd = "bgcolor=\"red\"";
     $skip_reason .= " conflict ";
   };
   if (IsSet($_REQUEST['SeeOnlyDiscussed']) && ($discussionOrder >= $Conf->omitFromDiscussionThreshold)) {
     $printMe = 0;
     $skip_reason .= " omitted from discussion ";
   };

   if (!$printMe) {
     // dump a placeholder
     print "<p> \n";
     print "<table align=center width=100% border=1>\n";
     print "<th colspan=2 $skip_color_cmd> <big> <big> <big><big>  ";
     print "Paper #$paperId: ($skip_reason)";
     print "</big></big></big> </big> </th> \n";
     print "</tr>\n";
     print "<tr> <th> Title: </th> <td> ";
     print nl2br(htmlentities($title));
     print " </td> </tr>\n";

     if (IsSet($_REQUEST['SeeConflictInfo']) && $_REQUEST['SeeConflictInfo']==1) {
       show_paper_conflicts_as_table_row($Conf, $paperId);
     };

     print "</table>\n";
     print "<p $page_break> </p>\n";

   } else { // print me!

     print "<p> \n";
     print "<table align=center width=100% border=1>\n";

     $titleColour = "";
     $titleWarning = "";
     if( $row['pcPaper'] ){
       $titleColour = " BGCOLOR='Red'";
       $titleWarning = " <b>*PC Paper*</b>";
     }


     if ( !IsSet($_REQUEST['SeeReviewerInfo']) || $_REQUEST['SeeReviewerInfo']==0 ) {
       print "<tr>\n";
       print "<th colspan=2 $titleColour> <big> <big> <big><big>  ";
       print "Paper #$paperId: $titleWarning";
       print "</big></big></big> </big> </th> \n";
       print "</tr>\n";
     } else {
       print "<tr>\n";
       print "<th $titleColour> <big> <big> <big> ";
       print "Paper #$paperId:";
       print "</big></big></big> </th>\n";
       print "<td>";
       print "<table border=1 align=center>\n";
       print "<tr bgcolor=$Conf->contrastColorOne>\n";
       print "<td> Primary Reviewers: </td>\n";
       print "<td>\n";
       $revQ="SELECT firstName, lastName, email "
	 . " FROM ContactInfo, PrimaryReviewer "
	 . " WHERE PrimaryReviewer.reviewer=ContactInfo.contactId "
	 . " AND PrimaryReviewer.paperId='$paperId'";
       $revR = $Conf->qe($revQ);
       if ($revR) {
	 $sep = "";
	 while($row=$revR->fetchRow()) {
	   print "<a href=\"mailto:$row[2]?Subject=Concerning%20Paper%20$paperId\">";
	   print "$sep$row[0] $row[1] ($row[2]) ";
	   print "</a>";
	   $sep =", ";
	 }
       }
       print "</td>\n";
       print "</tr>\n";

       print "<tr bgcolor=$Conf->contrastColorTwo>\n";
       print "<td> Secondary Reviewers: </td>\n";
       print "<td>\n";
       $revQ="SELECT firstName, lastName, email "
	 . " FROM ContactInfo, SecondaryReviewer "
	 . " WHERE SecondaryReviewer.reviewer=ContactInfo.contactId "
	 . " AND SecondaryReviewer.paperId='$paperId'";
       $revR = $Conf->qe($revQ);
       if ($revR) {
	 $sep = "";
	 while($row=$revR->fetchRow()) {
	   print "<a href=\"mailto:$row[2]?Subject=Concerning%20Paper%20$paperId\">";
	   print "$sep$row[0] $row[1] &lt;$row[2]&gt; ";
	   print "</a>";
	   $sep =", ";
	 }
       }
       print "</td>\n";
       print "</tr>\n";

       print "<tr bgcolor=$Conf->contrastColorOne>\n";
       print "<td> Reviews requested from: </td>\n";
       print "<td>\n";
       $revQ="SELECT firstName, lastName, email "
	 . " FROM ContactInfo, ReviewRequest "
	 . " WHERE ReviewRequest.asked=ContactInfo.contactId "
	 . " AND ReviewRequest.paperId='$paperId'";
       $revR = $Conf->qe($revQ);
       if ($revR) {
	 $sep = "";
	 while($row=$revR->fetchRow()) {
	   print "<a href=\"mailto:$row[2]?Subject=Concerning%20Paper%20$paperId\">";
	   print "$sep$row[0] $row[1] &lt;$row[2]&gt; ";
	   print "</a>";
	   $sep =", ";
	 }
       }
       print "</td>";
       print "</tr>";
       print "</table>";

       print "</td> </tr>\n";
     }

     // pc lead info?
     if ($pcLeadId != "") {
       print "<tr> <th> PC Lead: </th> <td> ";
       print $Conf->contactIdToHtml($pcLeadId);
       // print " ($pcLeadId) ";  // backup!
       print "</td></tr>\n";
     };

     // conflict info?
     if (IsSet($_REQUEST['SeeConflictInfo']) && $_REQUEST['SeeConflictInfo']==1) {
       show_paper_conflicts_as_table_row($Conf, $paperId);
     };

     // overall paper stuff:
     print "<tr> <th> Title: </th> <td> ";
     print nl2br(htmlentities($title));
     print " </td> </tr>\n";

     if ($_REQUEST['SeeAuthorInfo']) {
       print "<tr> <th> Contact </th> <td> ";
       print nl2br(htmlentities($contactInfo));
       print " </td> </tr>\n";

       print "<tr> <th> Author Info </th> <td> ";
       print nl2br(htmlentities($authorInfo));
       print " </td> </tr>\n";
     }

     print "<tr> <th> Abstract: </th> <td>";
     echo nl2br(htmlentities($abstract));
     print "</td> </tr>\n";


     print "<tr> <th> Authors Response: </th> <td ALIGN=LEFT>";
     echo nl2br(htmlentities($authorsResponse));
     print "</td> </tr>\n";
     print "</table>\n";

     //
     // Review summaries
     //
     print "<table align=center border=0>\n";
     print "<tr>\n";
     foreach( $graphs as $field => $name ) {
       print "<th>$name</th> ";
     };
     print "</tr>\n";
     print "<tr>\n";
     foreach( $graphs as $field => $name ) {
       if( $field == 'grade' ){
	 $q = "SELECT $field FROM PaperGrade WHERE paperID='$paperId' ORDER BY $field";
       } else {
	 $q = "SELECT $field FROM PaperReview WHERE paperID='$paperId' AND finalized = 1 ORDER BY $field";
       };
       print "<td align=center>";
       $Conf->graphValues($q, $field, $meritRange[$field]['min'], $meritRange[$field]['max']);
       print "</td>";
     };
     print "</tr>\n";
     print "</table>\n";



     //
     // Now print all the reviews
     //
    if ($_REQUEST['SeeOnlyFinalized']) {
      $finalizedStr = " AND PaperReview.finalized=1";
    } else {
      $finalizedStr ="";
    }

    $result2 = $Conf->qe("SELECT PaperReview.reviewer, "
			 . " PaperReview.paperReviewId, PaperReview.finalized, "
			 . " ContactInfo.firstName, ContactInfo.lastName, "
			 . " ContactInfo.email "
			 . " FROM PaperReview, ContactInfo "
			 . " WHERE PaperReview.paperId='$paperId'"
			 . " AND PaperReview.reviewer=ContactInfo.contactId"
			 . $finalizedStr
			 );

    if (!DB::isError($result2) && $result2->numRows() > 0) {
      $header = 0;
      $reviewerId = array();

      $i = 1;
      while($row = $result2->fetchRow(DB_FETCHMODE_ASSOC)) {
	$reviewer=$row['reviewer'];
	$reviewId=$row['paperReviewId'];
	$first=$row['firstName'];
	$last=$row['lastName'];
	$email=$row['email'];
	$finalized=$row['finalized'];

	$Review=ReviewFactory($Conf, $reviewer, $paperId);
	$lastModified=$Conf->printTime($Review->reviewFields['timestamp']);
	print "<table width=100%>";
	if ($i & 0x1 ) {
	  $color = $Conf->contrastColorOne;
	} else {
	  $color = $Conf->contrastColorTwo;
	}

	print "<tr bgcolor=$color>";

	if (IsSet($_REQUEST['SeeReviewerInfo']) && $_REQUEST['SeeReviewerInfo']==1) {
	  $reviewBy = "By $first $last ($email)";
	} else {
	  $reviewBy = "";
	}
	print "<th> <big> <big> Review #$reviewId For Paper #$paperId </big> $reviewBy </big> </th>";
	print "</tr>";

    print "<tr bgcolor=$color>";
    print "<th> (review last modified $lastModified) </th> </tr>\n";

    $gradeRes = $Conf -> qe("SELECT grade"
			  . " FROM PaperGrade "
			  . " WHERE paperId='$paperId' "
			  . "       AND contactId=$reviewer ");

    if (! $gradeRes ) {
      $Conf->errorMsg("Error in SQL " . $result->getMessage());
    }

    if ($gradeRow = $gradeRes->fetchRow(DB_FETCHMODE_ASSOC)) {
      $grade = "<EM>" . $gradeName[$gradeRow['grade']] . "</EM>";
    } else {
      $grade = "not entered yet";
    }

    print "<tr bgcolor=$color>";
    print "<th> Grade is $grade </th> </tr>\n";

	if ( ! $finalized ) {
	  print "<tr bgcolor=$color>";
	  print "<th> <big> <big> NOT FINALIZED </big></big> </th>";
	  print "</tr>";
	}
    
	print "<tr bgcolor=$color> <td> ";

	if ($Review->valid) {
	  $Review -> printViewable();
	}

	print "</td> </tr>";
	print "</table>";

	//    print "<tr> <td> <br> <br> <br> </td> </tr>";
	$i++;
      }
      //  print "</table>";
    }

//
// Now, print out the comments
//

    $comResult = $Conf -> qe("SELECT *, UNIX_TIMESTAMP(time) as unixtime "
			  . " FROM PaperComments "
			  . " WHERE paperId=$paperId "
			  . " ORDER BY time ");
    if (DB::isError($comResult)) {
      $Conf->errorMsg("Error in SQL " . $comResult->getMessage());
    }
    
    if ($comResult->numRows() < 1) {
      //
      // No comment if there are none...
      //
      // $Conf->infoMsg("There are no comments");
    } else {
      while ($row=$comResult->fetchRow(DB_FETCHMODE_ASSOC) ) {
	print "<table width=75% align=center>\n";

	$when = date ("l dS of F Y h:i:s A",
		      $row['unixtime']);

	print "<tr bgcolor=$Conf->infoColor>";
	print "<th align=left> Comment: $when </th>";
	print "<th align=right> For PC";
	if ($row['forReviewers']) {
	  print ", Reviewers";
	}
	if ($row['forAuthor']) {
	  print " and Author.";
	}
	print ". </th>";
	if ( $row['contactId'] == $_SESSION['Me']->contactId ) {
	  print "<th>";
	  $id=$row['commentId'];
	  $Conf->textButton("Delete?",
			    "PCNotes.php",
			    $Conf->mkHiddenVar('paperId', $paperId) .
			    $Conf->mkHiddenVar('killCommentId', $id));
	  print "</th>";
	}
	print "</tr>";
	print "<tr bgcolor=$Conf->contrastColorOne>\n";
	print "<td colspan=3>";
	print nl2br($row['comment']);
	print "</td>";
	print "</tr>";
	print "</table>";
	print "<br> <br>";
      }
    }

    print "<p $page_break> </p>\n";
  }
}
?>

</body>
<?php  $Conf->footer() ?>
</html>

