<?php 
include('../Code/confHeader.inc');
$_SESSION['Me'] -> goIfInvalid($Conf->paperSite);
$_SESSION['Me'] -> goIfNotChair($Conf->paperSite);
$Conf -> connect();
include('../PC/ListReviewsCommon.inc');

?>

<?php
  // code contributed by John Heidemann <johnh@isi.edu>
  // $Id: AssignMeetingOrder.php 278 2006-06-22 01:06:19Z johnh $
?>

<html>

<?php  $Conf->header("Assign PC Meeting Discussion Order for All Papers") ?>

<?php

function set_discussionOrder_computed($conf, $target, $value_method)
{
  // target is grade or overAllMerit
  if( $target == 'grade' ){
    $table = 'PaperGrade';
    $qual = "";
    $computed_stat = "AVG($table.grade)";
    $stat_order = "DESC";
  } elseif ($target == 'overAllMerit') {
    $table = 'PaperReview';
    $qual =  "   AND PaperReview.finalized=1 ";
    $computed_stat = "AVG($table.overAllMerit)";
    $stat_order = "DESC";
  } elseif( $target == 'zeroWorstGrades' ){
    $table = 'PaperGrade';
    $qual =  "   AND PaperGrade.paperId NOT IN ( "
      . "    SELECT paperId "
      . "    FROM PaperGrade "
      . "    WHERE grade > 2 "
      . "  )";
    $computed_stat = "AVG($table.grade)";
    $stat_order = "DESC";
  } elseif ($target == 'zeroWorstMerits') {
    $table = 'PaperReview';
    $qual =  "   AND PaperReview.finalized=1 " 
      . " AND PaperReview.paperId NOT IN ( "
      . "    SELECT paperId "
      . "    FROM PaperReview "
      . "    WHERE overAllMerit > 2 "
      . "  )";
    $computed_stat = "AVG($table.overAllMerit)";
    $stat_order = "DESC";
  } elseif ($target == 'sequentially') {
    $table = 'PaperReview';  // dummy
    $qual =  "   AND PaperReview.finalized=1 ";
    $computed_stat = "Paper.discussionOrder";
    $stat_order = "ASC";
  } else {
    $conf->errorMsg("Error: invalid target $target");
    exit;
  };
  $dc_qual = '';
  if ($value_method == 'dc_balance') {
    $dc_qual = " AND Paper.discussionOrder < 1000.0 ";
  };
  $query  = "SELECT $table.paperId, "
	. " $computed_stat AS merit "
	. " FROM $table, Paper "
	. " WHERE Paper.paperId = $table.paperId "
	. $qual . $dc_qual
	. " GROUP BY $table.paperId "
	. " ORDER BY merit $stat_order, $table.paperId ASC";
  $result = $conf->qe($query);
  if (DB::isError($result)) {
    $conf->errorMsg("Error in retrieving paper list " . $result->getMessage(). "\n" . $query);
    exit;
  };
  // read the paperIds into an array
  $paperIds = array();
  $values = array();
  $i = 0;
  while ($row = $result->fetchRow()) {
    $f = 0;
    $paperIds[$i] = $row[$f++];
    $values[$i] = $row[$f++];
    $i++;
  };
  // for dc balancing, given $i papers,
  //   we want to go through groups of 6: (best, good, middle, middle, ok, bad)
  // therefore reset the score every $i / 6 counts;
  // (why 6?  because I group the papers in 3s :-(,
  // and it seems like a reasonable number).
  $dc_balance_reset = floor($i / 6.0);
  $dc_count = 0;
  // now reset the orders
  for ($i = 0; $i < sizeof($paperIds); $i++) {
    $paperId = $paperIds[$i];
    if ($value_method == 'sequential') {
      $value = $i;
    } elseif ($value_method == 'inverse') {
      $value = 10.0 - $values[$i];
    } elseif ($value_method == 'last') {
      $value = 9999.0;
    } elseif ($value_method == 'dc_balance') {
      $value = $dc_count++;
      if ($dc_count >= $dc_balance_reset) {
	$dc_count = 0;
      };
    } else {
      $conf->errorMsg("Error: bad value_method $value_method");
      exit;
    };
    $query = "UPDATE Paper SET discussionOrder=$value WHERE paperId=$paperId";
    $request = $conf->qe($query);
  };
}



?>

<body>

<?php 
//
// Process actions from this form..
//
if (IsSet($_REQUEST['EnableAlgorithms'])) {
  // do something
  if (IsSet($_REQUEST['AlgoResetSequentially'])) {
    set_discussionOrder_computed($Conf, 'sequentially', 'sequential');
    $Conf->infoMsg("Ran algorithm: reset orders sequentially");
  } elseif (IsSet($_REQUEST['AlgoBestGrades'])) {
    set_discussionOrder_computed($Conf, 'grade', 'inverse');
    $Conf->infoMsg("Ran algorithm: Order by Best PC Grades");
  } elseif (IsSet($_REQUEST['AlgoBestMerit'])) {
    set_discussionOrder_computed($Conf, 'overAllMerit', 'inverse');
    $Conf->infoMsg("Ran algorithm: Order by Best Review Merit");
  } elseif (IsSet($_REQUEST['AlgoZeroWorstGrades'])) {
    set_discussionOrder_computed($Conf, 'zeroWorstGrades', 'last');
    $Conf->infoMsg("Ran algorithm: Papers Without Postive Grades at End");
  } elseif (IsSet($_REQUEST['AlgoZeroWorstMerits'])) {
    set_discussionOrder_computed($Conf, 'zeroWorstMerits', 'last');
    $Conf->infoMsg("Ran algorithm: Papers Without Postive Merit at End");
  } elseif (IsSet($_REQUEST['AlgoDCBalance'])) {
    set_discussionOrder_computed($Conf, 'overAllMerit', 'dc_balance');
    $Conf->infoMsg("Ran algorithm: Reorder in to Keep DC Balance");
  } else {
    $Conf->errorMsg("Confusion: algorithm enable checkbox checked, but no algoirthm picked");
  };
};

if (IsSet($_REQUEST['SetOrder']) && sizeof($_REQUEST['orders']) > 0) {
  // go through each one and update it
  if (sizeof($_REQUEST['ids']) != sizeof($_REQUEST['orders'])) {
    $Conf->errorMsg("Aack... mismatch in numbers of papers: "
		    . " ids: " . sizeof($_REQUEST['ids']) 
		    . " orders: " . sizeof($_REQUEST['orders']));
    exit;
  };
  for ($i = 0; $i < sizeof($_REQUEST['orders']); $i++) {
    $paperId = $_REQUEST['ids'][$i];
    $suggestedOrder = $_REQUEST['orders'][$i];
    // print "$paperId -> $suggestedOrder<BR>\n";
    $discussionOrder = get_paper_discussionOrder($Conf, $paperId);
    if ($suggestedOrder != "" && $suggestedOrder != "tba" && $discussionOrder != $suggestedOrder) {
      $query = "UPDATE Paper SET discussionOrder=\"$suggestedOrder\" WHERE paperId=\"$paperId\"";
      $request = $Conf->qe($query);
      if (DB::isError($result)) {
	$Conf->errorMsg("Request to change order for $paperId from $pcLeadId to $suggestedOrder FAILED");
      } else {
	$Conf->infoMsg("Changed order for $paperId from $discussionOrder to $suggestedOrder");
      };
    };
  };
};
?>


<p>
Use this page to assign an order for PC meeting discussion.
Each paper has an order value,
and lowest-numbered values go first.
<p>
(See the bottom of the page for ways to algorithmically set the order
and suggested workflow.)


<?php
//
// Make an array of all the valid paper indicies.
//
  $result = setupAllPapersArrays($Conf,
				 " WHERE acknowledged=1 AND withdrawn=0 ",
    				" ORDER BY (discussionOrder+0.0), paperId ");
  $f = 0;
  $countpapersforreview = $result[$f++];
  $allPapers = $result[$f++];
  $allPaperTitles = $result[$f++];
  $allPrimary = $result[$f++];
  $allSecondary = $result[$f++];
  $allPCLeadId = $result[$f++];
  $allPCPaper = $result[$f++];

  $allConflicts = $Conf->allMyConflicts($_SESSION['Me']->contactId);
  $pcConflicts = $Conf->allPCConflicts();

?>

<p>
Found <?php  echo $countpapersforreview ?> papers.

<FORM METHOD=POST ACTION="<?php echo $_SERVER[PHP_SELF] ?>">
<INPUT TYPE=SUBMIT name="SetOrder" value="Set Order">

     <table width="100%" cellpadding=1 cellspacing=1>

     <thead>
     <tr bgcolor="<?php echo $Conf->contrastColorTwo; ?>" >
     <th colspan=2 align="center">Discussion</th>
     <th colspan=3></th>
     </tr>
     <tr bgcolor="<?php echo $Conf->contrastColorTwo; ?>" >
     <th colspan=1 width="5%" valign="center" align="center"> Order </th>
     <th colspan=1 width="10%" valign="center" align="center"> Score </th>
     <th colspan=1 width="5%" valign="center" align="center"> Paper # </th>
     <th colspan=1 width="45%" valign="center" align="center"> Title </th>
     <th colspan=1 width="25%" valign="center" align="center"> PC Reviewers and [Lead] </th>
     </tr>
<?php 
     $color_count = 0;
     $cur_bg = $Conf->contrastColorZero;
     $alt_bg = $Conf->contrastColorOne;
     for($i = 0; $i < sizeof($allPapers); $i++) {
       $paperId = $allPapers[$i];
       //
       // All other fields indexed by papers
       //
       $title = $allPaperTitles[$paperId];
       $order = get_paper_discussionOrder($Conf, $paperId);
       $conflict = (IsSet($allConflicts[$paperId]) && $allConflicts[$paperId] != 0);

       print "<tr bgcolor=\"$cur_bg\"> ";
       if (++$color_count >= 3) {
         $t = $cur_bg;  $cur_bg = $alt_bg;  $alt_bg = $t;
         $color_count = 0;
       };

       print "<td> d$i </td>\n";
       print "<td>\n";
       print "  <INPUT TYPE=\"hidden\" NAME=\"ids[]\" VALUE=\"$paperId\">\n";
       print "  <INPUT TYPE=\"text\" NAME=\"orders[]\" SIZE=6 VALUE=\"$order\"> \n";
       print "</td>\n";
       $color = "";
       $pc_note = "";
       if ($allPCPaper[$paperId] == 1) {
	 $color = "bgcolor=\"#ff0000\"";
	 $pc_note = "*PC*";
       };
       print "<td align=center $color> $paperId $pc_note </td>\n";
       print "<td> ";
       $Conf->linkWithPaperId($title,
			      "../PC/PCAllAnonReviewsForPaper.php",
			      $paperId);
       print "</td>\n";

       // find the reviewers and leads
       print "<td>";
       $query = "SELECT PaperReview.reviewer, ContactInfo.firstName, ContactInfo.lastName "
		. " FROM PaperReview, ContactInfo "
		. " WHERE paperId=\"$paperId\" AND PaperReview.reviewer = ContactInfo.contactId "
		. " ORDER BY ContactInfo.lastName, ContactInfo.firstName ";
       $result = $Conf->qe($query);
       if ($conflict) {
	 print "(omitted due to conflict)";
       } elseif (DB::isError($result)) {
	 print "error\n";
       } else {
	 $n = 0;
	 $divider = "";
	 while ($row = $result->fetchRow()) {
	   $n++;
	   $f = 0;
	   $reviewer = $row[$f++];
	   $firstName = $row[$f++];
	   $lastName = $row[$f++];
	   $start = $end = "";
	   if ($reviewer == $allPCLeadId[$paperId]) {
	     $start = "<b>[";
	     $end = "]</b>";
	   };
	   print $divider . $start . $firstName . " " . $lastName . $end;
	   $divider = ", ";
	 };
	 if ($n == 0) {
	   print "<em>none</em>";
	 };
       };
       print "</td>\n";

       print "</tr>\n";
     }
 ?>
     </table>


     <br>
     <INPUT TYPE=SUBMIT name="SetOrder" value="Set Order">
       <br>
     <p>
     These are some automatic ways to assign a discussion order.
     One good strategy is to
     (1) sort the papers by your prefered metric
         (via order by best grades or merit),
     (2) throw out the papers that don't need to be considered
         (via put papers without postive grades or merit at end),
     (3) DC balance the non-end papers (via the "DC balance acceptable papers" button),
     and finally (4) reset the order values sequentially.
     <p>
     Since these mess with many settings, you <b>must</b> click the checkbox to enable them as a safety mechanism.
     <p>
     <INPUT TYPE=checkbox NAME=EnableAlgorithms VALUE=0> Enable the following algorithm buttons: <br>
     <INPUT TYPE=SUBMIT name="AlgoBestGrades" value="Order by Best PC Grades"><br>
     <INPUT TYPE=SUBMIT name="AlgoBestMerit" value="Order by Best Review Merit"><br>
     <INPUT TYPE=SUBMIT name="AlgoZeroWorstGrades" value="Papers Without Postive Grades at End"><br>
     <INPUT TYPE=SUBMIT name="AlgoZeroWorstMerits" value="Papers Without Postive Merit at End"><br>
     <INPUT TYPE=SUBMIT name="AlgoDCBalance" value="DC Balance Acceptable Papers"> (Ramesh Govindan normal form: cycle between good and bad in groups of 6 papers, only for papers with order values less than 1000)<br>
     <INPUT TYPE=SUBMIT name="AlgoResetSequentially" value="Reset Scores Sequentially"> (keeps current order)<br>
     </FORM>

</body>
<?php  $Conf->footer() ?>
</html>

