<?php 
include('../Code/confHeader.inc');
$_SESSION['Me'] -> goIfInvalid($Conf->paperSite);
$_SESSION['Me'] -> goIfNotChair($Conf->paperSite);
$Conf -> connect();
include('../PC/ListReviewsCommon.inc');

?>

<?php
  // code contributed by John Heidemann <johnh@isi.edu>
  // $Id: AssignPCLeads.php 247 2006-06-16 20:51:30Z johnh $
?>

<html>

<?php  $Conf->header("Assign PC Leads for All Papers") ?>

<?php
function get_paper_pcLeadId($conf, $paperId)
{
  $query = "SELECT pcLeadId FROM Paper WHERE paperId=$paperId";
  $result = $conf->qe($query);
  if ($result->numRows() == 1) {
    $row = $result->fetchRow();
    $value = $row[0];
    if (is_null($value)) {
      $value = 0;
    };
    return $value;
  };
  // NULL?
  return 0;
}

?>

<body>
<?php
if (IsSet($_REQUEST['EnableAlgorithms'])) {
  if (IsSet($_REQUEST['AlgoResetAll'])) {
    // AlgoClearLeads: just zero everything
    $query = "UPDATE Paper SET pcLeadId=0";
    $request = $Conf->qe($query);
    if (DB::isError($result)) {
      $Conf->errorMsg("Request to clear all leads FAILED");
    };
    $Conf->infoMsg("Ran algorithm: Reset All Leads");

  } elseif (IsSet($_REQUEST['AlgoClearBadOverall'])) {
    // AlgoClearBadOverall: assign any papers that have NO positive reviews "no reviewer"
    // now THIS is some SQL!
    $query = "UPDATE Paper SET pcLeadId=-1 "
      . "WHERE paperId IN " 
      . "  (SELECT paperId FROM "
      . "    ( SELECT paperId, MAX(overAllMerit) AS bestMerit FROM PaperReview GROUP BY paperId ) AS bestMerits "
      . "  WHERE bestMerits.bestMerit <= 2)";
    $request = $Conf->qe($query);
    if (DB::isError($result)) {
      $Conf->errorMsg("Request to clear all leads FAILED");
    };
    $Conf->infoMsg("Ran algorithm: Clear papers with no positive overall scores");

  } elseif (IsSet($_REQUEST['AlgoClearBadGrade'])) {
    // AlgoClearBadGrade: assign any papers that have NO positive GRADES "no reviewer"
    // now THIS is some SQL!
    $query = "UPDATE Paper SET pcLeadId=-1 "
      . "WHERE paperId IN " 
      . "  (SELECT paperId FROM "
      . "    ( SELECT paperId, MAX(grade) AS bestGrade FROM PaperGrade GROUP BY paperId ) AS bestGrades "
      . "  WHERE bestGrades.bestGrade <= 2)";
    $request = $Conf->qe($query);
    if (DB::isError($result)) {
      $Conf->errorMsg("Request to clear all leads FAILED");
    };
    $Conf->infoMsg("Ran algorithm: Clear papers with no positive grades");

  } elseif (IsSet($_REQUEST['AlgoBestReviewer'])) {
    // AlgoBestReviewer: assign as lead the top reviewer of any paper
    // (note, this algorithm is biased for lower id reviewers :-(

    // Ok, I *thought* the above sql was cool, but then I came up with
    // what's below.  So hairy it needs its own comments.

    $query = "UPDATE Paper "
      . " LEFT JOIN ("
           // find the first such reviewer (so we have only one)
      	   // ... the MIN(SHA1()) part is to arbitrarily but deterministically pick one of several equivalent reviewers
      . "  SELECT paperId, MIN(SHA1(CONCAT(reviewer,paperId))), reviewer AS firstBestReviewer  "
      . "  FROM  ( "
             // find the reviwers with that score
      . "    SELECT PaperReview.paperId, PaperReview.reviewer, PaperReview.overAllMerit "
      . "    FROM PaperReview "
      . "    INNER JOIN ( "
               // find the highest review score
      . "      SELECT paperId, MAX(overAllMerit) AS bestMerit "
      . "      FROM PaperReview "
      . "      WHERE finalized = 1 AND "
      		//  but only from PC members
      . "        PaperReview.reviewer IN ( "
      . "          SELECT contactId "
      . "          FROM PCMember "
      . "        ) "
      . "      GROUP BY paperId "
      . "      ) AS BestMerits "
      . "    ON PaperReview.paperId = BestMerits.paperId "
      . "      AND PaperReview.overAllMerit = BestMerits.bestMerit "
      . "    WHERE ( PaperReview.finalized = 1 "
        		//  but only from PC members
      . "        AND PaperReview.reviewer IN ( "
      . "          SELECT contactId "
      . "          FROM PCMember "
      . "        ) "
      . "      ) "
      . "    ) AS FirstBestReviewers "
      . "  GROUP BY paperId "
      . "  ) AS SingleFirstBestReviewers "
      . "ON Paper.paperId = SingleFirstBestReviewers.paperId "
      . "SET Paper.pcLeadId = SingleFirstBestReviewers.firstBestReviewer "
      . "WHERE Paper.pcLeadId = 0; ";
    $request = $Conf->qe($query);
    if (DB::isError($result)) {
      $Conf->errorMsg("Request to clear all leads FAILED");
    };
    $Conf->infoMsg("Ran algorithm: Best Reviewer");
  } else {
    $Conf->infoMsg("Warning: enable algorithm button set, but no algorithm chosen.");
  };
};

if (IsSet($_REQUEST['SetLeads']) && sizeof($_REQUEST['Requests']) > 0) {
  // go through each one and update it
  for ($i = 0; $i < sizeof($_REQUEST['Requests']); $i++) {
    $raw_request = $_REQUEST['Requests'][$i];
    $raw_request_pieces = explode(":", $raw_request);
    $paperId = $raw_request_pieces[0];
    $suggestedLeadId = $raw_request_pieces[1];

    $pcLeadId = get_paper_pcLeadId($Conf, $paperId);
    if ($suggestedLeadId != "" && $pcLeadId != $suggestedLeadId) {
      $query = "UPDATE Paper SET pcLeadId=\"$suggestedLeadId\" WHERE paperId=\"$paperId\"";
      $request = $Conf->qe($query);
      if (DB::isError($result)) {
	$Conf->errorMsg("Request to change lead for $paperId from $pcLeadId to $suggestedLeadId FAILED");
      } else {
	$Conf->infoMsg("Changed lead for $paperId from $pcLeadId to $suggestedLeadId");
      };
    };
  };
};
?>

<?php 
$Conf->infoMsg("If you have the word 'CONFLICT' next to a paper, "
	       . " the program chairs have registered a conflict of "
	       . " interest with you seeing those reviews. If you think "
	       . " this is an error, please contact the program chairs.");
//
// Process actions from this form..
//
//
// Make an array of all the valid paper indicies.
//

  $result = setupAllPapersArrays($Conf, " WHERE acknowledged=1 AND withdrawn=0 ");
  $i = 0;
  $countpapersforreview = $result[$i++];
  $allPapers = $result[$i++];
  $allPaperTitles = $result[$i++];
  $allPrimary = $result[$i++];
  $allSecondary = $result[$i++];

  $allConflicts = $Conf->allMyConflicts($_SESSION['Me']->contactId);
  $pcConflicts = $Conf->allPCConflicts();

  ?>

<p>
Use this page to assign PC members to lead discussion 
for each paper during the PC meeting.
Alternatively, set "no lead" for papers that are not to be discussed.
<p>
(See the bottom of the page for ways to algorithmically set all the leads.)


<p>
Found <?php  echo $countpapersforreview ?> papers.

<FORM METHOD=POST ACTION="<?php echo $_SERVER[PHP_SELF] ?>">
<INPUT TYPE=SUBMIT name="SetLeads" value="Set Leads">

     <table width="100%" cellpadding=0 cellspacing=0>

     <thead>
     <tr bgcolor="<?php $Conf->contrastColorTwo ?>" >
     <th colspan=1 width=5% valign="center" align="center"> Paper #</th>
     <th colspan=1 width=60% valign="center" align="center"> Title </th>
     <th colspan=1 width=10% valign="center" align="center"> Reviews </th>
     </tr>
<?php 
     $color_count = 0;
     $cur_bg = $Conf->contrastColorZero;
     $alt_bg = $Conf->contrastColorOne;
     for($i = 0; $i < sizeof($allPapers); $i++) {
       $paperId=$allPapers[$i];
       //
       // All other fields indexed by papers
       //
       $title=$allPaperTitles[$paperId];
       $primary=$allPrimary[$paperId];
       $secondary=$allSecondary[$paperId];

       // Check to see if there is a conflict
       $conflict = 0;
       if ( $allConflicts[$paperId] ) {
	 $conflict = 1;
       }

       print "<tr bgcolor=\"$cur_bg\"> ";
       if (++$color_count >= 3) {
         $t = $cur_bg;  $cur_bg = $alt_bg;  $alt_bg = $t;
         $color_count = 0;
       };
       if ( $conflict ) {
	 print "<td> $paperId </td>";
	 print "<td> $title </td> ";
	 print "<td> <b> CONFLICT </b> </td>\n";
       } else {
	 if ( $Conf->validTimeFor('AtTheMeeting', 0) 
	      && $pcConflicts[$paperId]
	      && ( $_SESSION['Me'] -> isPC && ! $_SESSION['Me'] -> isChair ) ) {
		//
		// Don't show anything
		//
	      } else {
		print "<td> $paperId </td>\n";
		print "<td> ";

		$Conf->linkWithPaperId($title,
				       "../PC/PCAllAnonReviewsForPaper.php",
				       $paperId);

		print "</td>\n";

		print "<td> <b>";

		// show potential leads
		$current_lead = get_paper_pcLeadId($Conf, $paperId);
		$extra_options = "<OPTION VALUE=\"$paperId:-1\" SELECTED>no lead</OPTION>\n";
		if ($current_lead == 0) {
		  $extra_options = "<OPTION VALUE=\"$paperId:-1\">no lead</OPTION>\n"
		    . "<OPTION VALUE=\"$paperId:0\" SELECTED>never specified</OPTION>\n";
		};
		$Conf->makePCSelector("Requests[]", $current_lead, 1, "$paperId:", $extra_options);

		print "</td>";
	      }
       }
       print "</tr>\n";
     }
 ?>
     </table>

<!-- summarize -->

<p>
     <table cellpadding=0 cellspacing=0>

     <thead>
     <tr bgcolor="<?php $Conf->contrastColorTwo ?>" >
     <th align=left> PC Member</th>
     <th align=right> Number of Leads </th>
     </tr>

<?php
 $query = "SELECT Paper.pcLeadId,COUNT(Paper.pcLeadId), ContactInfo.firstName, ContactInfo.lastName "
        . "  FROM Paper, ContactInfo "
        . "  WHERE (Paper.pcLeadId > 0 AND Paper.pcLeadId = ContactInfo.contactId ) "
        . "    OR ( (Paper.pcLeadId IS NULL OR Paper.pcLeadId <= 0) "
        . "         AND ContactInfo.contactId = 1 ) "
       . "  GROUP BY pcLeadId "
       . "  ORDER BY ContactInfo.lastName ";
  $result = $Conf->qe($query);
  if (DB::isError($result)) {
    $Conf->errorMsg("summary query FAILED");
  } else {
    $color_count = 0;
    $cur_bg = $Conf->contrastColorZero;
    $alt_bg = $Conf->contrastColorOne;
    while ($row = $result->fetchRow()) {
      $f = 0;
      $contactId = $row[$f++];
      $count = $row[$f++];
      $firstName = $row[$f++];
      $lastName = $row[$f++];
      if (is_null($contactId) || $contactId == 0) {
        $firstName = "";  $lastName = "never specified";
      } elseif ($contactId == -1) {
        $firstName = "";  $lastName = "no lead";
      };
      print "<tr bgcolor=\"$cur_bg\"> ";
      if (++$color_count >= 3) {
        $t = $cur_bg;  $cur_bg = $alt_bg;  $alt_bg = $t;
        $color_count = 0;
      };
      print "  <td> $firstName $lastName </td>\n"
	. "  <td align=right> $count </td>\n"
	. "</tr>\n";
    };
  };
?>

     </table>

<br>
<INPUT TYPE=SUBMIT name="SetLeads" value="Set Leads">
<br>
<p>
These are some automatic ways to assign reviewers.
     One good strategy is to just run them in sequence (reset all, force bad, pick best).
     Since these mess with many settings, you <b>must</b> click the checkbox to enable them as a safety mechanism.
<p>
     <INPUT TYPE=checkbox NAME=EnableAlgorithms VALUE=0> Enable the following algorithm buttons: <br>
<INPUT TYPE=SUBMIT name="AlgoResetAll" value="Reset All Leads"><br>
<INPUT TYPE=SUBMIT name="AlgoClearBadOverall" value="Force Papers with No Postive Reviews to no-lead"><br>
<INPUT TYPE=SUBMIT name="AlgoClearBadGrade" value="Force Papers with No Postive Grades to no-lead"><br>
<INPUT TYPE=SUBMIT name="AlgoBestReviewer" value="Set never-specified to best reviewer"><br>
</FORM>

</body>
<?php  $Conf->footer() ?>
</html>

