<?php 
include('../Code/confHeader.inc');
$_SESSION['Me'] -> goIfInvalid($Conf->paperSite);
$_SESSION['Me'] -> goIfNotChair($Conf->paperSite);
$Conf -> connect();
include('../PC/ListReviewsCommon.inc');
?>

<?php
  // code contributed by John Heidemann <johnh@isi.edu>
  // $Id: ListDiscussionAliases.php 222 2006-06-08 17:03:37Z johnh $
?>


<html>

<?php  $Conf->header("List E-mail Aliases for Each Paper") ?>

<body>

<p>
Below are a list of e-mail aliases for each paper with reviewers.
They include all reviewers on the PC and all chairs that are not in conflict.
<p>
This format should be suitable to be cut-and-pasted into <tt>/etc/aliases</tt>.

<?php

  // who are the chairs?
  $query = "SELECT Chair.contactId, ContactInfo.email "
	. " FROM Chair, ContactInfo "
	. " WHERE Chair.contactId = ContactInfo.contactId";
  $result = $Conf->qe($query);
  if (DB::isError($result)) {
    $Conf->errorMsg("Request to find chairs FAILED");
    exit;
  };
  $chairs = array();
  while ($row = $result->fetchRow()) {
    $chairs[$row[0]] = $row[1];
  };

  // now walk through all papers and reviewers
  $query = "SELECT PaperReview.paperId, PaperReview.reviewer, ContactInfo.email "
  	. " FROM PaperReview, ContactInfo "
  	. " WHERE "
	. "  PaperReview.reviewer = ContactInfo.contactId "
	. "  AND PaperReview.reviewer IN ( "
  	. "    SELECT contactId "
	. "    FROM PCMember " 
        . "    ) "
	. "ORDER BY paperId";
  $result = $Conf->qe($query);
  if (DB::isError($result)) {
    $Conf->errorMsg("Request to find revieers FAILED");
    exit;
  };
  $lastPaperId = -1;
  print "<BR>\n";
  print "<BR>\n";
  $divider = "";
  while ($row = $result->fetchRow()) {
    $f = 0;
    $paperId = $row[$f++];
    $reviewer = $row[$f++];
    $email = $row[$f++];
    // new paper?
    if ($paperId != $lastPaperId) {
      $lastPaperId = $paperId;
      print "<BR>\n";
      $divider = "";
      print strtolower($Conf->sessionName) . "-paper-" . $paperId . ": ";
      // do the chairs that are not in conflict
      foreach ($chairs as $chairContactId => $chairEmail) {
	if (!$Conf->checkConflict($paperId, $chairContactId)) {
	  print "$divider $chairEmail";
	  $divider = ",";
	} else {
	  // print "xxx "; // debugging
	};
      };
    };
    // do new person
    print "$divider $email";
    $divider = ",";
  };
  print "<BR>\n";

?>


</body>
<?php  $Conf->footer() ?>
</html>

