<?php 
include('../Code/confHeader.inc');
$_SESSION['Me'] -> goIfInvalid($Conf->paperSite);
$_SESSION['Me'] -> goIfNotChair('../index.php');
$Conf -> goIfInvalidActivity("PCSubmitReviewDeadline", $Conf->paperSite);
$Conf -> connect();
include('../PC/AskForReviewFunctions.inc');
?>

<html>

<?php
  $Conf->header("List Suggested Reviewers for Secondary Papers")
?>

<body>
<?php 
if (IsSet($_REQUEST['paperId']) && IsSet($_REQUEST['suggestion']) && IsSet($_REQUEST['action'])) {
  $suggestion = $_REQUEST['suggestion'];
  $paperId = $_REQUEST['paperId'];
  $action = $_REQUEST['action'];

  // print "doing action $action on paper $paperId for $suggestion\n";

  // find the user
  $suggestionInfo = new Contact();
  $suggestionInfo ->lookupById($suggestion, $Conf);
  $suggestionEmail = $suggestionInfo->email;
  if ($suggestionInfo->contactId == 0) {
    $Conf-> errorMsg("Unable to retrieve information about suggestion id $suggestion. Contact site admin.");
    exit();
  };

  //
  // Have they already been asked to review this paper?
  //
  $already_query = "SELECT suggestedReviewerId, paperId, approved, requestedBy FROM SuggestedReviewer WHERE paperId=$paperId AND suggestion=$suggestion";
  $already_result=$Conf->qe($already_query);
  
  if (DB::isError($already_result)) {
    $Conf->errorMsg("Error in query for paper $paperId, suggestion " . $suggestionEmail);
  } elseif ($already_result->numRows() < 1 ) {
    $Conf->errorMsg("Suggestion " . $suggestionEmail . " was not listed for paper #$paperId");
  } elseif ($already_result->numRows() > 1 ) {
    $Conf->errorMsg("Internal error: suggestion " . $suggestionEmail . " has multiple hits for paper #$paperId");
  } else {
    $already_row = $already_result->fetchRow();
    $approved = $already_row[2];
    $requestedBy = $already_row[3];

    if ($action === "reject") {
      $new_approved = -1;
    } elseif ($action === "approve") {
      $new_approved = 1;
    } elseif ($action === "invite") {
      $new_approved = 2;
    } elseif ($action === "accept") {
      $new_approved = 3;
    } elseif ($action === "decline") {
      $new_approved = -2;
    } else {
      $Conf->errorMsg("Internal error: bogus action");
      exit;
    };

    // change appvoved
    $query="UPDATE SuggestedReviewer "
		. " SET approved=$new_approved "
      		. " WHERE "
		. "   suggestion=$suggestion AND "
  		. "   paperId=$paperId AND "
  		. "   approved=$approved";
    $request=$Conf->qe($query);
    if (DB::isError($result)) {
      $Conf->errorMsg("Request to do $action to $suggestionEmail for paper $paperId failed for $query: " . $result->getMessage());
    } else {
      if ($action === "invite") {
	$suggestion_contact = new Contact();
	$suggestion_contact->lookupById($suggestion, $Conf);
	$paperList = addReviewerToPaper($Conf, $suggestion, $reviewerEmail, $paperId);
	if ($paperList != "") {
	  $Conf->sendReviewerRequest($_SESSION['Me'], $suggestion_contact->email, $paperList);
	}; 
      } elseif ($action === "decline") {
	$Conf->deleteAskReview($_SESSION['Me']->contactId,
			       -1,
			       $paperId,
			       $suggestion);
      } elseif ($action === "accept") {
	$Conf->acceptReviewRequest($suggestion, $paperId);
      };
      // non inivte
      $Conf->infoMsg("Do $action to $suggestionEmail for paper $paperId");
    };
  };
};
?>

<p>
This form lets the PC Chairs review suggested external reviewers
for conflicts, either approve or reject the suggestion,
and the invite approved suggestions to review papers.
  To change the status of a paper, click on the [reject], [approve], and [invite] links.
</p>

<br>
<?php
function wrap_email_for_action($paperId, $suggestion, $action)
{
  return " <a href=\"ListSuggestedReviewers.php?paperId=$paperId&suggestion=$suggestion&action=$action\">[<b>$action</b>]</a>";
}
?>

<?php 
  $result=$Conf->q("SELECT paperId, title, withdrawn, acknowledged "
		   . "FROM Paper "
		   . "WHERE withdrawn!=1 AND acknowledged=1 "
		   . "ORDER BY paperId");
  if (DB::isError($result)) {
    $Conf->errorMsg("Error in sql " . $result->getMessage());
  } else {
    $i = 0;
?>

<table border=1>
 <tr> <th width=5%> Paper # </th>
<th width=5%> Suggestions </th>
<th> Title </th>
</tr>
<?php 
  while ($row=$result->fetchRow()) {
    $paperId = $row[0];
    $title = $row[1];
    $withdrawn = $row[2];
    $acknowledged = $row[3];

    $number_and_color = determineSuggestionNumberAndColor($Conf, $paperId, "All");
    $num = $number_and_color[0];
    $color = $number_and_color[1];

    print "<tr> <td align=center> #$paperId </td>";
    print "<td align=center bgcolor=$color> $num </td>";
    print "<td>";

    $Conf->linkWithPaperId($title,
			   "../Assistant/AssistantViewSinglePaper.php",
			   $paperId);

    // check for conflicts
    $conflict_req = $Conf->q("SELECT COUNT(*) FROM PaperConflict WHERE "
			     . " authorId = " . $_SESSION['Me']->contactId
			     . " AND paperId=" . $paperId);
    $in_conflict = 0;
    if ($conflict_req) {
      $conflict_response = $conflict_req->fetchRow();
      if ($conflict_response[0] >= 1) {
	$in_conflict = 1;
	print " [conflict] ";
      };
    };

    // show repsponsible party
    $secondary_req = $Conf->q("SELECT ContactInfo.email FROM ContactInfo, SecondaryReviewer WHERE "
	 . " SecondaryReviewer.paperId=$paperId "
	 . " AND ContactInfo.contactId = SecondaryReviewer.reviewer");
    if ($secondary_req) {
      print "<BR> Secondary reviewers: ";
      $split = "";
      while ($secondary_response = $secondary_req->fetchRow()) {
	$s = $secondary_response[0];
	if ($in_conflict) {
	  $s = "(removed due to confict)";
	};
	print $split . $s;
	$split = ", ";
      };
    };

    // and list current recommendations, if any
    $suggestion_req = $Conf->q("SELECT ContactInfo.firstName, ContactInfo.lastName, ContactInfo.email, SuggestedReviewer.suggestion, SuggestedReviewer.approved FROM ContactInfo, SuggestedReviewer WHERE "
	 . " SuggestedReviewer.paperId=$paperId "
	 . " AND ContactInfo.contactId = SuggestedReviewer.suggestion");
    if ($suggestion_req) {
      $split = "<BR>&nbsp;&nbsp; ";
      while ($suggestion_response = $suggestion_req->fetchRow()) {
	$i = 0;
        $firstName = $suggestion_response[$i++];
        $lastName = $suggestion_response[$i++];
        $email = $suggestion_response[$i++];
        $suggestion = $suggestion_response[$i++];
        $approved = $suggestion_response[$i++];
	$wrap_begin = "";
	$wrap_end = "";
	if ($approved < 0) {
	  $wrap_begin = "<strike>";
	  $wrap_end = "</strike>";
	} elseif ($approved == 0) {
	  $wrap_end = wrap_email_for_action($paperId, $suggestion, "reject") 
	    . wrap_email_for_action($paperId, $suggestion, "approve");
	} elseif ($approved == 1) {
	  $wrap_end = wrap_email_for_action($paperId, $suggestion, "invite");
	} elseif ($approved == 2) {
	  $wrap_begin = "<b>";
	  $wrap_end = "</b>"
	    . wrap_email_for_action($paperId, $suggestion, "accept")
	    . wrap_email_for_action($paperId, $suggestion, "decline");
	} elseif ($approved == 3) {
	  $wrap_begin = "<b>";
	  $wrap_end = "</b>";
	} else {
	  $wrap_end = "<b>internal error: approved=$approved.</b>\n";
	};
	if ($in_conflict) {
	  print "<BR>(suggested reviewer omitted due to conflict) ";
	} else {
	  print $split . $wrap_begin .
		  htmlspecialchars($firstName . " " . $lastName . " <". $email . ">") . $wrap_end; // . " " . $approved;
	};
      };
    }

    print "</td> <tr> \n";
  }
?>

</table>
<?php 
    }
?>

<br>

</body>
<?php  $Conf->footer() ?>
</html>
