<?php 
include('../Code/confHeader.inc');
$_SESSION['Me'] -> goIfInvalid("../index.php");
$_SESSION['Me'] -> goIfNotPC('../index.php');
$Conf -> connect();

function spotSecondaryReviewers($howmany, $color)
{
  global $Conf;

  if ( $howmany == 0 ) {
    $result =$Conf->qe(
		       " SELECT Paper.paperId, Paper.title, Paper.withdrawn "
		       . " FROM Paper "
		       . " LEFT JOIN ReviewRequest "
		       . " ON ReviewRequest.paperId=Paper.paperId "
		       . " WHERE ReviewRequest.paperId IS NULL "
		       . "   AND Paper.withdrawn!=1 "
		       . " ORDER BY Paper.paperId ");
  } else {
    $result =$Conf->qe(		
       " SELECT Paper.paperId, Paper.title, Paper.withdrawn "
		       . " FROM Paper "
		       . " LEFT JOIN ReviewRequest "
		       . " ON ReviewRequest.paperId=Paper.paperId "
		       . " WHERE Paper.withdrawn!=1 "
		       . " GROUP BY ReviewRequest.paperId "
		       . " HAVING COUNT(ReviewRequest.paperId)=$howmany "
		       . " ORDER BY Paper.paperId ");
  }

  if (!DB::isError($result)) {
    $count=$result->numRows();
    $color_count = 0;
    $cur_bg = $Conf->contrastColorZero;
    $alt_bg = $Conf->contrastColorOne;
    print "<table align=center width=80%> ";
    print "<tr bgcolor=\"" . $Conf->contrastColorTwo . "\"> <th colspan=2> There are $count Papers With $howmany Assigned Secondary </th> </tr>";
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
      $paperId=$row['paperId'];
      $title=$row['title'];
      print "<tr bgcolor=\"$cur_bg\"> ";
      if (++$color_count >= 3) {
	$t = $cur_bg;  $cur_bg = $alt_bg;  $alt_bg = $t;
	$color_count = 0;
      };
      print "<td bgcolor=\"$color\"> $paperId </td><td> ";

      $Conf->linkWithPaperId("$title",
			     "../PC/PCAllAnonReviewsForPaper.php",
			     $paperId);

      print "</td> </tr>";
    }
    print "</table>";
  }
}

function spotReviews($howmany, $color, $finalized=0)
{
  global $Conf;


  if ( $howmany == 0 ) {
    $result =$Conf->qe(
		       " SELECT Paper.paperId, Paper.title, Paper.withdrawn "
		       . " FROM Paper "
		       . " LEFT JOIN PaperReview "
		       . " ON PaperReview.paperId=Paper.paperId "
		       . " WHERE PaperReview.paperId IS NULL "
		       . "   AND Paper.withdrawn!=1 "
		       . " ORDER BY Paper.paperId ");

  } else {
    if ( $finalized ) {
      $fin = " AND PaperReview.finalized=1 ";
    }

    $result =$Conf->qe(
		       " SELECT Paper.paperId, Paper.title, Paper.withdrawn "
		       . " FROM Paper "
		       . " LEFT JOIN PaperReview "
		       . " ON PaperReview.paperId=Paper.paperId "
		       . $fin
		       . " WHERE Paper.withdrawn!=1 "
		       . " GROUP BY PaperReview.paperId "
		       . " HAVING COUNT(PaperReview.paperId)=$howmany "
		       . " ORDER BY Paper.paperId ");
  }
  if (!DB::isError($result)) {
    $count=$result->numRows();
    print "<table align=center width=80%> ";
    print "<tr  bgcolor=\"" . $Conf->contrastColorTwo . "\"> ";
    if ( $finalized ) {
      print "<th colspan=2> There are $count Papers With $howmany Finalized Reviews </th> </tr>";
    } else {
      print "<th colspan=2> There are $count Papers With $howmany Started Reviews </th> </tr>";
    }
    $color_count = 0;
    $cur_bg = $Conf->contrastColorZero;
    $alt_bg = $Conf->contrastColorOne;
    while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
      $paperId=$row['paperId'];
      $title=$row['title'];
      print "<tr bgcolor=\"$cur_bg\"> ";
      if (++$color_count >= 3) {
	$t = $cur_bg;  $cur_bg = $alt_bg;  $alt_bg = $t;
	$color_count = 0;
      };
      print "<td bgcolor=\"$color\"> $paperId </td><td> ";


      $Conf->linkWithPaperId("$title",
			     "../PC/PCAllAnonReviewsForPaper.php",
			     $paperId);

      print "</td> </tr>";


    }
    print "</table>";
  }
}

if (! $_SESSION['Me'] -> isChair && ! $Conf -> validTimeFor('PCMeetingView', 0) ) {
  $Conf->infoMsg("You shouldn't be here");
  exit();
}

?>

<html>
<?php  $Conf->header("Spot Problem Papers") ?>
<body>

<h1> Which papers do not have enough assigned secondary reviewers? </h1>

<?php 
  spotSecondaryReviewers(0, $Conf->bitSadColor);
  print "<br> <br>";
  spotSecondaryReviewers(1, $Conf->veryHappyColor);
?>

<h1> Which papers do not have enough <b> <i> started </i> </b> reviews? </h1>
<?php 
   spotReviews(0, $Conf->verySadColor, 0);
   print "<br> <br>";
   spotReviews(1, $Conf->bitSadColor, 0);
   print "<br> <br>";
   spotReviews(2, $Conf->neutralColor, 0);
   print "<br> <br>";
   spotReviews(3, $Conf->bitHappyColor, 0);
?>

<h1> Which papers do not have enough <b> <i> finished </i> </b> reviews? </h1>
<?php 
   spotReviews(0, $Conf->bitSadColor, 1);
   print "<br> <br>";
   spotReviews(1, $Conf->neutralColor, 1);
   print "<br> <br>";
   spotReviews(2, $Conf->bitHappyColor, 1);
   print "<br> <br>";
   spotReviews(3, $Conf->veryHappyColor, 1);
?>

</body>
<?php  $Conf->footer() ?>
</html>
