<?php 
  //
  // Preferences.inc
  // by John Heidemann
  // Copyright (C) 2006
  //
  // This code handles preference searching.
  //
  // Pardon my poor PHP.  Probably should be in a class or something.
  //

  //
  // paper preferenc stuff
  //
  // Note that preferences are stored in the database as INTEGERS
  // from 10-50, but presented to the user divided by 10, from 1.0 to 5.0
  //
  function determine_paper_default_preference ($conf, $paperId, $contactId)
  {
	  // now THAT's some SQL :-)
	  $pref_result = $conf->qe("SELECT AVG(interest) AS avgInterest, "
				   . "   MAX(interest) AS maxInterest "
				   . " FROM PaperTopic "
				   . " LEFT JOIN TopicInterest "
				   . " ON PaperTopic.topicId = TopicInterest.topicId "
				   . " WHERE paperId="  . $paperId 
				   . "   AND TopicInterest.contactId=" . $contactId);
	  if (DB::isError($pref_result)) {
		  $conf->errorMsg("Error in retrieving preference for paper " . $paperId . ", contact " . $contactId . ", " . $pref_result->getMessage());
		  return 0;
	  };
	  if ($pref_result->numRows() == 0) {
		  // no hits => neutral
		  echo "no hits ";
		  return 28;
	  };
	  if ($pref_result->numRows() != 1) {
		  $conf->errorMsg("Error: auto-preference query on paper " . $paperId . ", contact " . $contactId . " gives unexpected " . $pref_result->numRows() . " rows and message " . $pref_result->getMessage());
	  };
	  $pref_row = $pref_result->fetchRow();
	  // echo "hit: " . $pref_row[0] . " " . $pref_row[1] . " ";
	  // next line averages avg and max and rounds to multiples of 0.2
	  // add 2 to each to go from [0-2] scale to [2-4]
	  $pref = floor(($pref_row[0] + 2 + $pref_row[1] + 2) * 2.5) * 2;
	  $pref += 2;  // bonus because we had a hit
	  if ($pref < 10) {
		  $pref = 10;
	  };
	  if ($pref > 50) {
		  $pref = 50;
	  };
	  return $pref;
  }

  function determine_paper_current_preference ($conf, $paperId, $contactId)
  {
	  $pref_result = $conf->qe("SELECT preference "
				   . " FROM PCPaperPreference "
				   . " WHERE paperId=" . $paperId 
				   . "    AND contactId=" . $contactId);
	  if (DB::isError($pref_result)) {
		  $conf->errorMsg("Error in retrieving preference for paper " . $paperId . ", contact " . $contactId . ", " . $pref_result->getMessage());
		  return 0;
	  };
	  if ($pref_result->numRows() == 0) {
		  return 0;
	  };
	  if ($pref_result->numRows() != 1) {
		  $conf->errorMsg("Error: preference query on paper " . $paperId . ", contact " . $contactId . " gives unexpected " . $pref_result->numRows() . " rows.");
	  };
	  $pref_row = $pref_result->fetchRow(DB_FETCHMODE_ASSOC);
	  return $pref_row['preference'];
  }

  function determine_paper_preference ($conf, $paperId, $contactId)
  {
	  $p = determine_paper_current_preference ($conf, $paperId, $contactId);
	  if ($p > 0) {
		  return $p;
	  };
	  $p = determine_paper_default_preference ($conf, $paperId, $contactId);
	  return $p;
  }

  function update_paper_preferences ($conf, $contactId)
  {
	  // figure out about prior prefs
	  $prior_result = $conf->qe("SELECT paperId, preference "
				    . " FROM PCPaperPreference "
				    . " WHERE contactId=" . $contactId);
	  $prior_paper_preferences = array();
	  while ($row = $prior_result->fetchRow()) {
		  // echo "prior_result: " . $row[0] . " => " . $row[1] . "<br>\n";
		  $prior_paper_preferences[$row[0]] = $row[1];
	  };

	  // now submit new ones
	  foreach ($_REQUEST['preference'] as $paperId => $pref) {
		  // echo $paperId . " => " . $pref . "<br>\n";
		  // xxx: should confirm that $pref and $paperId are both numeric :-(
		  if (IsSet($prior_paper_preferences[$paperId])) {
			  // echo $paperId . "  was set<br>\n";
			  $result = $conf->qe("UPDATE PCPaperPreference "
					      . " SET preference=" . addslashes($pref) . " " 
					      . " WHERE paperId=" . addslashes($paperId) . " " 
					      . "    AND contactId=" . $contactId);
		  } else {
			  // echo $paperId . "  was NOT set<br>\n";
			  $result = $conf->qe("INSERT INTO PCPaperPreference "
					      . " SET contactId=" . $contactId . ", "
					      . "     paperId=" . addslashes($paperId) . ", " 
					      . "     preference=" . addslashes($pref));
		  };
	  };
  }

?>


