<?php 

function addReviewerToPaper($Conf, $reviewerId, $reviewerEmail, $paperId) 
{
  $paperList = "";
  //
  // Have they already been asked to review this paper?
  //
  $query = "SELECT reviewRequestId, paperId FROM ReviewRequest WHERE paperId=$paperId AND asked=$reviewerId";
  $result=$Conf->qe($query);

  if ( !DB::isError($result) && $result->numRows() >= 1 ) {
    $Conf->errorMsg("Reviewer #$reviewerId (" . $reviewerEmail . ") has already been asked to review $paperId");
  } else {
    //
    // Pull up the paper information to get the title, etc
    //
    $result=$Conf->qe("SELECT title FROM Paper WHERE paperId='$paperId'");
    if ( DB::isError($result) ) {
      $Conf->errorMsg("Odd - couldn't find paper #$paperId - skipping assignment"
		      . $result->getMessage());
    } else {
      $row=$result->fetchRow();
      $title=$row[0];
      $paperList= $paperList . "Paper #$paperId, $title\n";
      // $Conf->errorMsg("Do $paperId");
      $query="INSERT INTO ReviewRequest SET "
	. " requestedBy=" . $_SESSION['Me']->contactId. ", "
	. " asked=$reviewerId, "
	. " paperId=$paperId";
      $request=$Conf->qe($query);
      if (DB::isError($result)) {
	$Conf->errorMsg("Request to review paper $paperId failed for $query: " . $result->getMessage());
      }
    }
  }
  return $paperList;
}

function determineSuggestionNumberAndColor($conf, $paperId, $ReviewKind) 
{
  $color = $conf->neutralColor;

  // first look at raw count
  if ($ReviewKind === "All") {
    $constraint = "";
  } else {
    $constraint = "AND requestedBy=" . $_SESSION['Me']->contactId;
  };
  $count_response = $conf->q("SELECT COUNT(*) FROM SuggestedReviewer WHERE "
		 . " SuggestedReviewer.paperId=$paperId " . $constraint);
  if ( $count_response ) {
    $count_row = $count_response->fetchRow();
    $num = $count_row[0];
  } else {
    $num = "0";
  };
  if ($num < 1) {
    $color = $conf->verySadColor;
  } elseif ($num < 2) {
    $color = $conf->bitSadColor;
  };

  // next check for acceptance and override
  $accept_response = $conf->q("SELECT COUNT(*) FROM SuggestedReviewer WHERE "
		 . " SuggestedReviewer.paperId=$paperId AND SuggestedReviewer.approved >= 3");
  if ($accept_response) {
    $accept_row = $accept_response->fetchRow();
    $accept_num = $accept_row[0];
  } else {
    $accept_num = 0;
  };
  if ($accept_num >= 1) {
    $color = $conf->bitHappyColor;
  };

  $response = array();
  $response[0] = $num;
  $response[1] = $color;
  return $response;
}

?>
