<?php
  // common code for ListReviews and AssignPCLeads

function countPapers($conf, $table, $where)
{
  $a = array();  /// will be returned

  $query = "SELECT $table.paperId, COUNT(*) "
    . " FROM $table "
    . $where
    . " GROUP BY $table.paperId ";

  $result=$conf->qe($query);
  if (DB::isError($result)) {
    $conf->errorMsg("Error in retrieving $table count " . $result->getMessage());
  } else {
    while ($row = $result->fetchRow()) {
      $id=$row[0];
      $a[$id] = $row[1];
    }
  }
  return $a;
}


function setupAllPapersArrays($conf, $limits="", $order=" ORDER BY paperId")
{
  // returns results through these global varibles:
  $countpapersforreview = 0; // needs return
  $allPapers=array(); // needs return---indexed sequentially
       //
       // All other fields indexed by papers
       //
  $allPaperTitles=array(); //  needs return
  $allPrimary=array();  //  needs return
  $allSecondary=array(); //  needs return
  // these were not acutally used:
//  $allReviewRequest=array();
//  $allStartedReviews=array();
//  $allFinishedReviews=array();
  $allPCLeadId=array();
  $allPCPaper=array();

  $result=$conf->qe("SELECT Paper.paperId, Paper.title, "
		    . " Paper.acknowledged, Paper.withdrawn, Paper.pcLeadId, Paper.pcPaper, Paper.discussionOrder "
		    . " FROM Paper "
		    . $limits
		    . " $order ");
  $i = 0;
  if (DB::isError($result)) {
    $conf->errorMsg("Error in retrieving paper list " . $result->getMessage());
  } else {
    while ($row = $result->fetchRow()) {
      $f = 0;
      $id = $row[$f++];
      $allPapers[$i] = $id;
      $allPaperTitles[$id] = $conf->safeHtml($row[$f++]);
      $allSubmitted[$id] = $row[$f++];
      $allWithdrawn[$id] = $row[$f++];
      $allPCLeadId[$id] = $row[$f++];
      $allPCPaper[$id] = $row[$f++];
      $i++;
    }
  }
  $countpapersforreview = $i;
  $allPrimary = countPapers($conf, "PrimaryReviewer", "");
  $allSecondary = countPapers($conf, "SecondaryReviewer", "");
  // these were not acutally used:
//  $allReviewRequest = countPapers($conf, "ReviewRequest", "");
//  $allStartedReviews = countPapers($conf, "PaperReview", "WHERE (PaperReview.finalized!=0)");
//  $allFinishedReviews = countPapers($conf, "PaperReview", "WHERE (PaperReview.finalized=0)");

  // return all values as an (unnamed) object
  return array($countpapersforreview,
	       $allPapers,
	       $allPaperTitles,
	       $allPrimary,
	       $allSecondary,
	       $allPCLeadId,
	       $allPCPaper
    );
}

function get_paper_discussionOrder($conf, $paperId)
{
  $query = "SELECT discussionOrder FROM Paper WHERE paperId=$paperId";
  $result = $conf->qe($query);
  if (DB::isError($result)) {
    $conf->errorMsg("Error in retrieving paper list " . $result->getMessage());
    exit;
  };
  if ($result->numRows() == 1) {
    $row = $result->fetchRow();
    $value = $row[0];
    if (is_null($value)) {
      $value = "tbd";
    };
    return $value;
  };
  // NULL?
  return 1000.0;
}

?>
