<?php 
include('../Code/confHeader.inc');
$_SESSION['Me'] -> goIfInvalid($Conf->paperSite);
$_SESSION['Me'] -> goIfNotPC($Conf->paperSite);
  // this code is inc'ed from SuggestForSecondaryReview.php
  // with $ReviewKind set to All or Secondary
if (!($ReviewKind === "Secondary" || $ReviewKind === "All")) {
  $Conf->errorMsg("Internal error: ReviewKind not set.");
  exit;
};
if ($ReviewKind === "All") {
  // only chair can do this for all
  $_SESSION['Me'] -> goIfNotChair('../index.php');
};
$Conf -> goIfInvalidActivity("PCSubmitReviewDeadline", $Conf->paperSite);
$Conf -> connect();
include('AskForReviewFunctions.inc');
?>

<html>

<?php
if ($ReviewKind === "Secondary") {
  $title = "Your Secondary";
} elseif ($ReviewKind === "All") {
  $title = "All";
} else {
  $title = "ERROR";
};
$Conf->header("Suggest People to be Reviewers For $title Papers")
?>

<body>
<?php 
if (IsSet($_REQUEST['AddSuggestions']) && sizeof($_REQUEST['Requests']) > 0) {
  $firstEmail = $_REQUEST['firstEmail'];
  $firstEmail = trim($firstEmail);
  if ( $firstEmail == "" ) {
    $Conf->errorMsg("You need to enter an email address!");
  } else {
    //
    // Check to see if they exist
    //
    $id = $Conf->emailRegistered($_REQUEST['firstEmail']);

    if ( $id == 0 ) {
      //
      // Try to add them if they don't exist...
      //
      $Conf->infoMsg("Creating an account for " . $firstEmail);
      if (!IsSet($_REQUEST['firstFirstName']) || $_REQUEST['firstFirstName'] == "" ||
	  !IsSet($_REQUEST['firstLastName']) || $_REQUEST['firstLastName'] == "" ||
	  !IsSet($_REQUEST['firstAffiliation']) || $_REQUEST['firstAffiliation'] == "") {
        $Conf->errorMsg("No one with e-mail " . $firstEmail . " is in the database, so you need to enter full contact information (name and affiliation) before they can be suggested as a reviewer.");
      } else {
        $Conf->log("Create email contact for " . $firstEmail . ", suggested by ", $_SESSION['Me']);
  
        $newguy = new Contact();
        $newguy -> initialize(addslashes(trim($_REQUEST['firstFirstName'])),
			    addslashes(trim($_REQUEST['firstLastName'])),
			    addslashes($firstEmail),
			    addslashes(trim($_REQUEST['firstAffiliation'])),
			    "", "");
        $result = $newguy -> addToDB($Conf);
        if ( $result ) {
          // take out next line because unsolicited e-mail is confusing
          // $newguy -> sendAccountInfo($Conf);
          $id = $Conf->emailRegistered($firstEmail);
        } else {
          $Conf->errorMsg("Had trouble creating an account for " . $firstEmail);
        }
      }
    };

    //  $Conf -> infoMsg("$firstEmail registered as user $id");
    if ($id != 0) {
      $paperList="";
      for ($i = 0; $i < sizeof($_REQUEST['Requests']); $i++) {
        $paperId=$_REQUEST['Requests'][$i];
        //
        // Have they already been asked to review this paper?
        //
        $query = "SELECT suggestedReviewerId, paperId FROM SuggestedReviewer WHERE paperId=$paperId AND suggestion=$id";
        $result=$Conf->qe($query);
    
        if ( !DB::isError($result) && $result->numRows() >= 1 ) {
          $Conf->errorMsg("Reviewer #$id (" . $firstEmail . ") has already been suggsted to review $paperId");
        } else {
          //
          // Pull up the paper information to get the title, etc
          //
          $result=$Conf->qe("SELECT title FROM Paper WHERE paperId='$paperId'");
          if ( DB::isError($result) ) {
  	  $Conf->errorMsg("Odd - couldn't find paper #$paperId - skipping assignment"
    			. $result->getMessage());
          } else {
	    $row=$result->fetchRow();
    	    $title=$row[0];
    	    $paperList= $paperList . "Paper #$paperId, $title\n";
    	    // $Conf->errorMsg("Do $paperId");
    	    $query="INSERT INTO SuggestedReviewer SET "
  		  . " requestedBy=" . $_SESSION['Me']->contactId. ", "
  		  . " suggestion=$id, "
  		  . " paperId=$paperId";
    	    $request=$Conf->qe($query);
    	    if (DB::isError($result)) {
    	      $Conf->errorMsg("Request to review paper $paperId failed for $query: " . $result->getMessage());
     	    } else {
	      $Conf->infoMsg("Suggesting $firstEmail for paper $paperId");
  	    };
          };
        };
      };
    };
  };
};
?>

<p>
Please use this form to suggest people to review for a given paper.
(You do not need to ask the reviewers first, that will happen
after they are checked for conflicts.)
The PC Chairs will check for conflicts and then
let you invite unconflicted reviewers.
</p>

<p>
Please suggest 2-4 or more people
	per paper (ideally from different institutions) in case we have conflicts.
</p>

<p>
<?php
print "Shades of red in the Assigned column indicate papers that need additional suggestions ";
if ($ReviewKind === "Secondary") {
  print " by you.";
} elseif ($ReviewKind === "All") {
  print " by anyone.";
} else {
  print " INTERNAL ERROR.";
};
?>
</p>


<h3> Make new suggestions for secondary reviewers  </h3><p>

<h4> Enter contact information address of your suggestion (or just the e-mail if you know they are in the database), then select which papers they can review:  </h4> 

<FORM METHOD=POST ACTION="<?php echo $_SERVER[PHP_SELF] ?>">
First Name: <INPUT TYPE=TEXT name=firstFirstName value="<?php echo $_REQUEST['firstFirstName']?>" size=20> <br>
Last Name: <INPUT TYPE=TEXT name=firstLastName value="<?php echo $_REQUEST['firstLastName']?>" size=20> <br>
Affiliation: <INPUT TYPE=TEXT name=firstAffiliation value="<?php echo $_REQUEST['firstAffiliation']?>" size=20> <br>
<b>E-mail:</b> <INPUT TYPE=TEXT name=firstEmail value="<?php echo $_REQUEST['firstEmail']?>" size=40> <br><br>
<INPUT TYPE=SUBMIT name="AddSuggestions" value="Make Suggestions">
<br>

<?php 
$tables = "";
$constraint = "";
if ($ReviewKind === "Secondary") {
  $tables = ", SecondaryReviewer ";
  $constraint = " AND SecondaryReviewer.reviewer='" . $_SESSION['Me']->contactId. "' "
    . "AND Paper.paperId=SecondaryReviewer.paperId ";
} elseif ($ReviewKind === "All") {
  // no additional constraints
} else {
  $Conf->errorMsg("Internal error: ReviewKind $ReviewKind seems strange.");
};
$result=$Conf->q("SELECT Paper.paperId, Paper.title, Paper.withdrawn, Paper.acknowledged "
		 . "FROM Paper " . $tables
		 . "WHERE Paper.withdrawn != 1 AND Paper.acknowledged=1 "
		 . $constraint
		 . "ORDER BY Paper.paperId ");

if (DB::isError($result)) {
  $Conf->errorMsg("Error in sql " . $result->getMessage());
} else {
  $i = 0;
?>
<table border=1>
 <tr> <th width=5%> Paper # </th>
<th width=5%> Assign </th>
<th width=5%> Assigned </th>
<th> Title </th>
</tr>
<?php 
  while ($row=$result->fetchRow()) {
    $id = $row[0];
    $title = $row[1];
    $withdrawn = $row[2];
    $acknowledged = $row[3];
    $me =$_SESSION['Me']->contactId;
    $number_and_color = determineSuggestionNumberAndColor($Conf, $id, $ReviewKind);
    $num = $number_and_color[0];
    $color = $number_and_color[1];
    print "<tr> <td align=center> $id </td>";
    print "<td align=center> <INPUT TYPE=checkbox NAME=Requests[] VALUE='$id'> </td> ";
    print "<td align=center bgcolor=$color> $num </td>";
    print "<td>";

    $Conf->linkWithPaperId($title,
			   "ShowAbstract.php",
			   $id);

    // and list current recommendations, if any
    $r3 = $Conf->q("SELECT ContactInfo.email FROM ContactInfo, SuggestedReviewer WHERE "
	 . " SuggestedReviewer.paperId=$id AND requestedBy=$me "
	 . " AND ContactInfo.contactId = SuggestedReviewer.suggestion");
    if ( $r3 ) {
      $split = "<BR>(Current suggestions: ";
      while ($r3r = $r3->fetchRow()) {
	print $split . $r3r[0];
	$split = ", ";
      };
      if ($split == ", ") {
        print ")";
      };
    }

    print "</td> <tr> \n";
  }
  print "</table>";
}

?>
<br>
<INPUT TYPE=SUBMIT name="AddSuggestions" value="Make Suggestions">
</FORM>

</body>
<?php  $Conf->footer() ?>
</html>
